<?php 
class module_chiffres extends abstract_module{
	
	public function before(){
		$this->oLayout=new _layout('template1');
		
		//$this->oLayout->addModule('menu','menu::index');
	}
	
	
	public function _index(){
	    //on considere que la page par defaut est la page de listage
	    $this->_list();
	}
	
	
	public function _list(){
		
		$tChiffres=model_chiffres::getInstance()->findAll();
		
		$oView=new _view('chiffres::list');
		$oView->tChiffres=$tChiffres;
		
				$oView->tJoinmodel_auteur=model_auteur::getInstance()->getSelect();
		
		$this->oLayout->add('main',$oView);
		 
	}
		
	
	
	public function _new(){
		$tMessage=$this->processSave();
	
		$oChiffres=new row_chiffres;
		
		$oView=new _view('chiffres::new');
		$oView->oChiffres=$oChiffres;
		
				$oView->tJoinmodel_auteur=model_auteur::getInstance()->getSelect();
		
		$oPluginXsrf=new plugin_xsrf();
		$oView->token=$oPluginXsrf->getToken();
		$oView->tMessage=$tMessage;
		
		$this->oLayout->add('main',$oView);
	}
			
	
	
	public function _edit(){
		$tMessage=$this->processSave();
		
		$oChiffres=model_chiffres::getInstance()->findById( _root::getParam('id') );
		
		$oView=new _view('chiffres::edit');
		$oView->oChiffres=$oChiffres;
		$oView->tId=model_chiffres::getInstance()->getIdTab();
		
				$oView->tJoinmodel_auteur=model_auteur::getInstance()->getSelect();
		
		$oPluginXsrf=new plugin_xsrf();
		$oView->token=$oPluginXsrf->getToken();
		$oView->tMessage=$tMessage;
		
		$this->oLayout->add('main',$oView);
	}
		
	
	
	public function _show(){
		$oChiffres=model_chiffres::getInstance()->findById( _root::getParam('id') );
		
		$oView=new _view('chiffres::show');
		$oView->oChiffres=$oChiffres;
		
				$oView->tJoinmodel_auteur=model_auteur::getInstance()->getSelect();

		$this->oLayout->add('main',$oView);
	}
		
	
	
	public function _delete(){
		$tMessage=$this->processDelete();

		$oChiffres=model_chiffres::getInstance()->findById( _root::getParam('id') );
		
		$oView=new _view('chiffres::delete');
		$oView->oChiffres=$oChiffres;
		
				$oView->tJoinmodel_auteur=model_auteur::getInstance()->getSelect();

		$oPluginXsrf=new plugin_xsrf();
		$oView->token=$oPluginXsrf->getToken();
		$oView->tMessage=$tMessage;
		
		$this->oLayout->add('main',$oView);
	}
		
	

	private function processSave(){
		if(!_root::getRequest()->isPost() ){ //si ce n'est pas une requete POST on ne soumet pas
			return null;
		}
		
		$oPluginXsrf=new plugin_xsrf();
		if(!$oPluginXsrf->checkToken( _root::getParam('token') ) ){ //on verifie que le token est valide
			return array('token'=>$oPluginXsrf->getMessage() );
		}
	
		$iId=_root::getParam('id',null);
		if($iId==null){
			$oChiffres=new row_chiffres;	
		}else{
			$oChiffres=model_chiffres::getInstance()->findById( _root::getParam('id',null) );
		}
		
		$tColumn=array('produit','ventes','auteur_id');
		foreach($tColumn as $sColumn){
			$oChiffres->$sColumn=_root::getParam($sColumn,null) ;
		}
		
		
		if($oChiffres->save()){
			//une fois enregistre on redirige (vers la page liste)
			_root::redirect('chiffres::list');
		}else{
			return $oChiffres->getListError();
		}
		
	}
	
	
	public function processDelete(){
		if(!_root::getRequest()->isPost() ){ //si ce n'est pas une requete POST on ne soumet pas
			return null;
		}
		
		$oPluginXsrf=new plugin_xsrf();
		if(!$oPluginXsrf->checkToken( _root::getParam('token') ) ){ //on verifie que le token est valide
			return array('token'=>$oPluginXsrf->getMessage() );
		}
	
		$oChiffres=model_chiffres::getInstance()->findById( _root::getParam('id',null) );
				
		$oChiffres->delete();
		//une fois enregistre on redirige (vers la page liste)
		_root::redirect('chiffres::list');
		
	}
		
	
	public function after(){
		$this->oLayout->show();
	}
	
	
}

